require 'fox'

module Fox
  class FX_App
    alias appName getAppName
    alias vendorName getVendorName
    alias defaultVisual getDefaultVisual
    alias defaultVisual= setDefaultVisual
    alias monoVisual getMonoVisual
    alias root getRoot
    alias cursorWindow getCursorWindow
    alias focusWindow getFocusWindow
    alias mainWindow getMainWindow
    alias normalFont getNormalFont
    alias normalFont= setNormalFont
    alias waitCursor getWaitCursor
    alias waitCursor= setWaitCursor
    alias typingSpeed getTypingSpeed
    alias typingSpeed= setTypingSpeed
    alias clickSpeed getClickSpeed
    alias clickSpeed= setClickSpeed
    alias scrollSpeed getScrollSpeed
    alias scrollSpeed= setScrollSpeed
    alias scrollDelay getScrollDelay
    alias scrollDelay= setScrollDelay
    alias blinkSpeed getBlinkSpeed
    alias blinkSpeed= setBlinkSpeed
    alias animSpeed getAnimSpeed
    alias animSpeed= setAnimSpeed
    alias menuPause getMenuPause
    alias menuPause= setMenuPause
    alias tooltipPause= setTooltipPause
    alias tooltipTime getTooltipTime
    alias tooltipTime= setTooltipTime
    alias dragDelta getDragDelta
    alias dragDelta= setDragDelta
    alias wheelLines getWheelLines
    alias wheelLines= setWheelLines
    alias borderColor getBorderColor
    alias borderColor= setBorderColor
    alias baseColor getBaseColor
    alias baseColor= setBaseColor
    alias hiliteColor getHiliteColor
    alias hiliteColor= setHiliteColor
    alias shadowColor getShadowColor
    alias shadowColor= setShadowColor
    alias backColor getBackColor
    alias backColor= setBackColor
    alias foreColor getForeColor
    alias foreColor= setForeColor
    alias selforeColor getSelforeColor
    alias selforeColor= setSelforeColor
    alias selbackColor getSelbackColor
    alias selbackColor= setSelbackColor
    alias tipforeColor getTipforeColor
    alias tipforeColor= setTipforeColor
    alias tipbackColor getTipbackColor
    alias tipbackColor= setTipbackColor
  end
  class FXApp
    alias sleepTime  getSleepTime
    alias sleepTime= setSleepTime
  end
  class FX_ArrowButton
    alias state getState
    alias state= setState
    alias helpText getHelpText
    alias helpText= setHelpText
    alias tipText getTipText
    alias tipText= setTipText
    alias arrowStyle getArrowStyle
    alias arrowStyle= setArrowStyle
    alias arrowSize getArrowSize
    alias arrowSize= setArrowSize
    alias justify getJustify
    alias justify= setJustify
    alias arrowColor getArrowColor
    alias arrowColor= setArrowColor
  end
  class FX_Button
    alias state= setState
    alias state getState
    alias buttonStyle= setButtonStyle
    alias buttonStyle getButtonStyle
  end
  class FX_CheckButton
    alias check= setCheck
    alias check getCheck
    alias checkButtonStyle= setCheckButtonStyle
    alias checkButtonStyle getCheckButtonStyle
    alias boxColor getBoxColor
    alias boxColor= setBoxColor
  end
  class FX_ColorBar
    alias hue= setHue
    alias hue getHue
    alias sat= setSat
    alias sat getSat
    alias val= setVal
    alias val getVal
    alias barStyle= setBarStyle
    alias barStyle getBarStyle
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
  end
  class FX_ColorDialog
    alias rgba= setRGBA
    alias rbga getRGBA
    alias opaqueOnly? isOpaqueOnly
    alias opaqueOnly= setOpaqueOnly
  end
  class FX_ColorSelector
    alias rgba= setRGBA
    alias rbga getRGBA
    alias opaqueOnly= setOpaqueOnly
    alias opaqueOnly? isOpaqueOnly
  end
  class FX_ColorWell
    alias rgba= setRGBA
    alias rbga getRGBA
    alias opaqueOnly= setOpaqueOnly
    alias opaqueOnly? isOpaqueOnly
    alias tipText= setTipText
    alias tipText getTipText
    alias helpText= setHelpText
    alias helpText getHelpText
  end
  class FX_ColorWheel
    alias hue= setHue
    alias hue getHue
    alias sat= setSat
    alias sat getSat
    alias val= setVal
    alias val getVal
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
  end
  class FX_ComboBox
    alias editable? isEditable
    alias editable= setEditable
    alias text= setText
    alias text getText
    alias to_s getText
    alias numColumns= setNumColumns
    alias numColumns getNumColumns
    alias numItems getNumItems
    alias numVisible getNumVisible
    alias numVisible= setNumVisible
    alias currentItem= setCurrentItem
    alias currentItem getCurrentItem
    alias font= setFont
    alias font getFont
    alias comboStyle= setComboStyle
    alias comboStyle getComboStyle
    alias backColor= setBackColor
    alias backColor getBackColor
    alias textColor= setTextColor
    alias textColor getTextColor
    alias selBackColor= setSelBackColor
    alias selBackColor getSelBackColor
    alias selTextColor= setSelTextColor
    alias selTextColor getSelTextColor
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
    alias paneShown? isPaneShown
  end
  class FX_Cursor
    alias width getWidth
    alias heigh getHeight
    alias hotX getHotX
    alias hotY getHotY
  end
  class FXDataTarget
    alias value getValue
    alias value= setValue
  end
  class FX_DC
    alias app getApp
    alias foreground getForeground
    alias foreground= setForeground
    alias background getBackground
    alias background= setBackground
    alias dashPattern getDashPattern
    alias dashOffset getDashOffset
    alias dashLength getDashLength
    alias lineWidth getLineWidth
    alias lineWidth= setLineWidth
    alias lineCap getLineCap
    alias lineCap= setLineCap
    alias lineJoin getLineJoin
    alias lineJoin= setLineJoin
    alias lineStyle getLineStyle
    alias lineStyle= setLineStyle
    alias fillStyle getFillStyle
    alias fillStyle= setFillStyle
    alias fillRule getFillRule
    alias fillRule= setFillRule
    alias function getFunction
    alias function= setFunction
    alias tile getTile
    alias stippleBitmap getStippleBitmap
    alias stipplePattern getStipplePattern
    alias clipRegion setClipRegion
    alias clipRectangle getClipRectangle
    alias clipX getClipX
    alias clipY getClipY
    alias clipWidth getClipWidth
    alias clipHeight getClipHeight
    alias textFont getTextFont
    alias textFont= setTextFont
  end
  class FX_Delegator
    alias delegate getDelegate
    alias delegate= setDelegate
  end
  class FX_Dial
    alias value getValue
    alias value= setValue
    alias revolutionIncrement= setRevolutionIncrement
    alias revolutionIncrement getRevolutionIncrement
    alias notchSpacing= setNotchSpacing
    alias notchSpacing getNotchSpacing
    alias notchOffset= setNotchOffset
    alias notchOffset getNotchOffset
    alias dialStyle= setDialStyle
    alias dialStyle getDialStyle
    alias notchColor= setNotchColor
    alias notchColor getNotchColor
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
  end
  class FX_Dict
    alias length no
    alias size no
#   alias delete remove
    alias has_key? has_key
    alias include? has_key
    alias key? has_key
    alias member? has_key
    alias empty? empty
  end
  class FX_DirBox
    alias directory getDirectory
    alias directory= setDirectory
  end
  class FX_DirDialog
    alias directory getDirectory
    alias directory= setDirectory
    alias dirBoxStyle getDirBoxStyle
    alias dirBoxStyle= setDirBoxStyle
  end
  class FX_DirList
    alias currentFile getCurrentFile
    alias currentFile= setCurrentFile
    alias directory getDirectory
    alias directory= setDirectory
    alias pattern getPattern
    alias pattern= setPattern
    alias matchMode getMatchMode
    alias matchMode= setMatchMode
    alias showFiles getShowFiles
    alias showFiles= setShowFiles
    alias showHiddenFiles getShowHiddenFiles
    alias showHiddenFiles= setShowHiddenFiles
    alias associations getAssociations
    alias associations= setAssociations
  end
  class FX_DirSelector
    alias directory getDirectory
    alias directory= setDirectory
    alias dirBoxStyle getDirBoxStyle
    alias dirBoxStyle= setDirBoxStyle
  end
  class FX_Document
    alias modified? isModified
    alias modified= setModified
    alias title getTitle
    alias title= setTitle
    alias filename getFilename
    alias filename= setFilename
  end
  class FX_DragCorner
    alias hiliteColor getHiliteColor
    alias hiliteColor= setHiliteColor
    alias shadowColor getShadowColor
    alias shadowColor= setShadowColor
  end
  class FX_Drawable
    alias width getWidth
    alias height getHeight
    alias visual getVisual
    alias visual= setVisual
  end
  class FX_DriveBox
    alias drive getDrive
    alias drive= setDrive
  end
  class FX_FileDialog
    alias filename= setFilename
    alias filename getFilename
    alias pattern= setPattern
    alias pattern getPattern
    alias patternList  getPatternList
    alias patternList= setPatternList
    alias currentPattern= setCurrentPattern
    alias currentPattern  getCurrentPattern
    alias directory= setDirectory
    alias directory  getDirectory
    alias itemSpace= setItemSpace
    alias itemSpace  getItemSpace
    alias fileBoxStyle= setFileBoxStyle
    alias fileBoxStyle  getFileBoxStyle
    alias selectMode= setSelectMode
    alias selectMode  getSelectMode
    alias readOnlyShown= showReadOnly
    alias readOnlyShown  shownReadOnly
    alias readOnly= setReadOnly
    alias readOnly  getReadOnly
  end
  class FX_Icon
    alias transparentColor  getTransparentColor
    alias transparentColor= setTransparentColor
  end
  class FX_IconDict
    alias app getApp
    alias iconPath getIconPath
    alias iconPath= setIconPath
  end
  class FX_FileItem
    alias assoc getAssoc
    alias size getSize
    alias date getDate
  end
  class FX_FileList
    alias currentFile= setCurrentFile
    alias currentFile getCurrentFile
    alias directory= setDirectory
    alias directory getDirectory
    alias pattern= setPattern
    alias pattern getPattern
    alias matchMode getMatchMode
    alias matchMode= setMatchMode
    alias hiddenFilesShown getHiddenFilesShown
    alias hiddenFilesShown= setHiddenFilesShown
    alias onlyDirectoriesShown getOnlyDirectoriesShown
    alias onlyDirectoriesShown= setOnlyDirectoriesShown
    alias associations= setAssociations
    alias associations getAssociations
  end
  class FX_FileSelector
    alias filename= setFilename
    alias filename  getFilename
    alias pattern= setPattern
    alias pattern  getPattern
    alias patternList= setPatternList
    alias patternList  getPatternList
    alias currentPattern= setCurrentPattern
    alias currentPattern  getCurrentPattern
    alias directory= setDirectory
    alias directory  getDirectory
    alias itemSpace= setItemSpace
    alias itemSpace  getItemSpace
    alias fileBoxStyle= setFileBoxStyle
    alias fileBoxStyle  getFileBoxStyle
    alias selectMode= setSelectMode
    alias selectMode  getSelectMode
    alias readOnlyShown= setReadOnlyShown
    alias readOnlyShown  getReadOnlyShown
    alias readOnly= setReadOnly
    alias readOnly  getReadOnly
  end
  class FX_Font
    alias name getName
    alias size getSize
    alias weight getWeight
    alias slant getSlant
    alias encoding getEncoding
    alias setWidth getSetWidth
    alias hints getHints
    alias fontDesc getFontDesc
    alias fontDesc= setFontDesc
    alias minChar getMinChar
    alias maxChar getMaxChar
    alias fontWidth getFontWidth
    alias fontHeight getFontHeight
    alias fontAscent getFontAscent
    alias fontDescent getFontDescent
    alias fontLeading getFontLeading
    alias fontSpacing getFontSpacing
  end
  class FX_FontDialog
    alias fontSelection getFontSelection
    alias fontSelection= setFontSelection
  end
  class FX_FontSelector
    alias fontSelection getFontSelection
    alias fontSelection= setFontSelection
  end
  class FX_Frame
    alias frameStyle getFrameStyle
    alias frameStyle= setFrameStyle
    alias borderWidth getBorderWidth
    alias padTop getPadTop
    alias padTop= setPadTop
    alias padBottom getPadBottom
    alias padBottom= setPadBottom
    alias padLeft getPadLeft
    alias padLeft= setPadLeft
    alias padRight getPadRight
    alias padRight= setPadRight
    alias hiliteColor getHiliteColor
    alias hiliteColor= setHiliteColor
    alias shadowColor getShadowColor
    alias shadowColor= setShadowColor
    alias borderColor getBorderColor
    alias borderColor= setBorderColor
    alias baseColor getBaseColor
    alias baseColor= setBaseColor
  end
  class FX_GLContext
    alias visual getVisual
  end
  class FX_GLShape
    alias tipText getTipText
    alias tipText= setTipText
  end
  class FX_GLViewer
    alias viewport getViewport
    alias material getMaterial
    alias material= setMaterial
    alias fieldOfView= setFieldOfView
    alias fieldOfView  getFieldOfView
    alias zoom= setZoom
    alias zoom  getZoom
    alias distance= setDistance
    alias distance  getDistance
    alias scale= setScale
    alias scale  getScale
    alias orientation= setOrientation
    alias orientation  getOrientation
    alias center= setCenter
    alias center  getCenter
    alias eyeVector getEyeVector
    alias eyePosition getEyePosition
    alias helpText= setHelpText
    alias helpText  getHelpText
    alias tipText= setTipText
    alias tipText  getTipText
    alias offset= setOffset
    alias offset  getOffset
    alias transform getTransform
    alias invTransform getInvTransform
    alias scene= setScene
    alias scene  getScene
    alias selection= setSelection
    alias selection  getSelection
    alias projection= setProjection
    alias projection  getProjection
    alias viewLock= setViewLock
    alias viewLock  getViewLock
    alias backgroundColor= setBackgroundColor
    alias backgroundColor  getBackgroundColor
    alias ambientColor= setAmbientColor
    alias ambientColor  getAmbientColor
    alias zSortFunc= setZSortFunc
    alias zSortFunc  getZSortFunc
    alias maxHits= setMaxHits
    alias maxHits  getMaxHits
    alias turboMode  getTurboMode
    alias turboMode= setTurboMode
    alias light  getLight
    alias light= setLight
  end
  class FX_GLVisual
    alias redSize getRedSize
    alias greenSize  getGreenSize
    alias blueSize  getBlueSize
    alias alphaSize  getAlphaSize
    alias depthSize  getDepthSize
    alias stencilSize  getStencilSize
    alias accumRedSize  getAccumRedSize
    alias accumGreenSize  getAccumGreenSize
    alias accumBlueSize  getAccumBlueSize
    alias accumAlphaSize  getAccumAlphaSize
    alias redSize= setRedSize
    alias greenSize= setGreenSize
    alias blueSize= setBlueSize
    alias alphaSize= setAlphaSize
    alias depthSize= setDepthSize
    alias stencilSize= setStencilSize
    alias accumRedSize= setAccumRedSize
    alias accumGreenSize= setAccumGreenSize
    alias accumBlueSize= setAccumBlueSize
    alias accumAlphaSize= getAccumAlphaSize
    alias actualRedSize getActualRedSize
    alias actualGreenSize getActualGreenSize
    alias actualBlueSize getActualBlueSize
    alias actualAlphaSize getActualAlphaSize
    alias actualDepthSize getActualDepthSize
    alias actualStencilSize getActualStencilSize
    alias actualAccumRedSize getActualAccumRedSize
    alias actualAccumGreenSize getActualAccumGreenSize
    alias actualAccumBlueSize getActualAccumBlueSize
    alias actualAccumAlphaSize getActualAccumAlphaSize
    alias doubleBuffer? isDoubleBuffer
    alias stereo? isStereo
    alias accelerated? isAccelerated
  end
  class FX_GroupBox
    alias text= setText
    alias text  getText
    alias to_s  getText
    alias groupBoxStyle= setGroupBoxStyle
    alias groupBoxStyle  getGroupBoxStyle
    alias font= setFont
    alias font  getFont
    alias textColor= setTextColor
    alias textColor  getTextColor
  end
  class FX_HeaderItem
    alias text getText
    alias to_s getText
    alias text= setText
    alias icon getIcon
    alias icon= setIcon
    alias data getData
    alias data= setData
    alias size getSize
    alias size= setSize
    alias arrowDir getArrowDir
    alias arrowDir= setArrowDir
  end
  class FX_Header
    alias numItems getNumItems
    alias font getFont
    alias font= setFont
    alias textColor getTextColor
    alias textColor= setTextColor
    alias headerStyle getHeaderStyle
    alias headerStyle= setHeaderStyle
    alias helpText getHelpText
    alias helpText= setHelpText
  end
  class FX_IconItem
    alias text getText
    alias text= setText
    alias to_s getText
    alias bigIcon getBigIcon
    alias bigIcon= setBigIcon
    alias miniIcon getMiniIcon
    alias miniIcon= setMiniIcon
    alias data getData
    alias data= setData
    alias selected? isSelected
    alias selected= setSelected
    alias enabled? isEnabled
    alias enabled= setEnabled
    alias draggable? isDraggable
    alias draggable= setDraggable
    alias iconOwned isIconOwned
    alias iconOwned= setIconOwned
  end
  class FX_IconList
    alias numItems getNumItems
    alias numRows getNumRows
    alias numCols getNumCols
    alias header getHeader
    alias numHeaders getNumHeaders
    alias itemWidth getItemWidth
    alias itemHeight getItemHeight
    alias currentItem getCurrentItem
    alias anchorItem getAnchorItem
    alias anchorItem= setAnchorItem
    alias cursorItem getCursorItem
    alias font getFont
    alias font= setFont
    alias textColor getTextColor
    alias textColor= setTextColor
    alias selBackColor getSelBackColor
    alias selBackColor= setSelBackColor
    alias selTextColor getSelTextColor
    alias selTextColor= setSelTextColor
    alias itemSpace getItemSpace
    alias itemSpace= setItemSpace
    alias listStyle getListStyle
    alias listStyle= setListStyle
    alias helpText getHelpText
    alias helpText= setHelpText
  end
  class FX_Id
    alias app getApp
    alias userData getUserData
    alias userData= setUserData
  end
  class FX_Image
    alias data getData
    alias options getOptions
    alias options= setOptions
    alias channels getChannels
  end
  class FX_ImageView
    alias image getImage
    alias image= setImage
  end
  class FX_InputDialog
    alias text getText
    alias text= setText
    alias numColumns getNumColumns
    alias numColumns= setNumColumns
    alias to_s getText
  end
  class FX_JPGIcon
    alias quality getQuality
    alias quality= setQuality
  end
  class FX_JPGImage
    alias quality getQuality
    alias quality= setQuality
  end
  class FX_Label
    alias text getText
    alias to_s getText
    alias text= setText
    alias icon getIcon
    alias icon= setIcon
    alias font getFont
    alias font= setFont
    alias textColor getTextColor
    alias textColor= setTextColor
    alias justify getJustify
    alias justify= setJustify
    alias iconPosition getIconPosition
    alias iconPosition= setIconPosition
    alias helpText getHelpText
    alias helpText= setHelpText
    alias tipText getTipText
    alias tipText= setTipText
  end
  class FX_ListItem
    alias text= setText
    alias text getText
    alias to_s getText
    alias icon= setIcon
    alias icon getIcon
    alias data= setData
    alias data getData
    alias selected= setSelected
    alias selected? isSelected
    alias enabled= setEnabled
    alias enabled? isEnabled
    alias draggable= setDraggable
    alias draggable? isDraggable
    alias iconOwned= setIconOwned
    alias iconOwned isIconOwned
  end
  class FX_List
    alias numItems getNumItems
    alias numVisible getNumVisible
    alias numVisible= setNumVisible
    alias currentItem getCurrentItem
    alias anchorItem= setAnchorItem
    alias anchorItem getAnchorItem
    alias cursorItem getCursorItem
    alias font= setFont
    alias font getFont
    alias textColor getTextColor
    alias textColor= setTextColor
    alias selBackColor getSelBackColor
    alias selBackColor= setSelBackColor
    alias selTextColor getSelTextColor
    alias selTextColor= setSelTextColor
    alias listStyle getListStyle
    alias listStyle= setListStyle
    alias helpText= setHelpText
    alias helpText getHelpText
  end
  class FX_ListBox
    alias numItems getNumItems
    alias numVisible getNumVisible
    alias numVisible= setNumVisible
    alias currentItem= setCurrentItem
    alias currentItem getCurrentItem
    alias font= setFont
    alias font getFont
    alias backColor= setBackColor
    alias backColor getBackColor
    alias textColor= setTextColor
    alias textColor getTextColor
    alias selBackColor= setSelBackColor
    alias selBackColor getSelBackColor
    alias selTextColor= setSelTextColor
    alias selTextColor getSelTextColor
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
    alias paneShown? isPaneShown
  end
  class FX_Matrix
    alias matrixStyle= setMatrixStyle
    alias matrixStyle getMatrixStyle
    alias numRows= setNumRows
    alias numRows getNumRows
    alias numColumns= setNumColumns
    alias numColumns getNumColumns
  end
  class FX_MDIChild
    alias normalX= setNormalX
    alias normalY= setNormalY
    alias normalWidth= setNormalWidth
    alias normalHeight= setNormalHeight
    alias normalX getNormalX
    alias normalY getNormalY
    alias normalWidth getNormalWidth
    alias normalHeight getNormalHeight
    alias iconX= setIconX
    alias iconY= setIconY
    alias iconWidth= setIconWidth
    alias iconHeight= setIconHeight
    alias iconX getIconX
    alias iconY getIconY
    alias iconWidth getIconWidth
    alias iconHeight getIconHeight
    alias title= setTitle
    alias title getTitle
    alias hiliteColor getHiliteColor
    alias shadowColor getShadowColor
    alias baseColor getBaseColor
    alias borderColor getBorderColor
    alias titleColor getTitleColor
    alias titleBackColor getTitleBackColor
    alias hiliteColor= setHiliteColor
    alias shadowColor= setShadowColor
    alias baseColor= setBaseColor
    alias borderColor= setBorderColor
    alias titleColor= setTitleColor
    alias titleBackColor= setTitleBackColor
    alias maximized? isMaximized
    alias minimized? isMinimized
    alias windowIcon getWindowIcon
    alias windowIcon= setWindowIcon
    alias windowMenu getWindowMenu
    alias windowMenu= setWindowMenu
    alias font= setFont
    alias font getFont
  end
  class FX_MDIClient
    alias activeChild getActiveChild
    alias cascadeX= setCascadeX
    alias cascadeY= setCascadeY
    alias cascadeX getCascadeX
    alias cascadeY getCascadeY
  end
  class FX_MenuButton
    alias menu= setMenu
    alias menu getMenu
    alias xOffset= setXOffset
    alias xOffset getXOffset
    alias yOffset= setYOffset
    alias yOffset getYOffset
    alias buttonStyle= setButtonStyle
    alias buttonStyle getButtonStyle
    alias popupStyle= setPopupStyle
    alias popupStyle getPopupStyle
    alias attachment= setAttachment
    alias attachment getAttachment
  end
  class FX_MenuCaption
    alias text= setText
    alias text getText
    alias to_s getText
    alias icon= setIcon
    alias icon getIcon
    alias font= setFont
    alias font getFont
    alias textColor getTextColor
    alias textColor= setTextColor
    alias selBackColor getSelBackColor
    alias selBackColor= setSelBackColor
    alias selTextColor getSelTextColor
    alias selTextColor= setSelTextColor
    alias hiliteColor= setHiliteColor
    alias hiliteColor getHiliteColor
    alias shadowColor= setShadowColor
    alias shadowColor getShadowColor
    alias helpText= setHelpText
    alias helpText getHelpText
  end
  class FX_MenuCascade
    alias menu= setMenu
    alias menu getMenu
  end
  class FX_MenuCommand
    alias checked? isChecked
    alias radioChecked? isRadioChecked
    alias accelText= setAccelText
    alias accelText getAccelText
  end
  class FX_MenuSeparator
    alias hiliteColor= setHiliteColor
    alias hiliteColor getHiliteColor
    alias shadowColor= setShadowColor
    alias shadowColor getShadowColor
  end
  class FX_MenuTitle
    alias menu= setMenu
    alias menu getMenu
  end
  class FX_OptionMenu
    alias current= setCurrent
    alias current getCurrent
    alias currentNo= setCurrentNo
    alias currentNo getCurrentNo
    alias popup= setPopup
    alias popup getPopup
    alias popped? isPopped
  end
  class FX_Packer
    alias frameStyle= setFrameStyle
    alias frameStyle getFrameStyle
    alias packingHints= setPackingHints
    alias packingHints getPackingHints
    alias borderWidth getBorderWidth
    alias padTop= setPadTop
    alias padTop getPadTop
    alias padBottom= setPadBottom
    alias padBottom getPadBottom
    alias padLeft= setPadLeft
    alias padLeft getPadLeft
    alias padRight= setPadRight
    alias padRight getPadRight
    alias hiliteColor= setHiliteColor
    alias hiliteColor getHiliteColor
    alias shadowColor= setShadowColor
    alias shadowColor getShadowColor
    alias borderColor= setBorderColor
    alias borderColor getBorderColor
    alias baseColor= setBaseColor
    alias baseColor getBaseColor
    alias hSpacing= setHSpacing
    alias hSpacing getHSpacing
    alias vSpacing= setVSpacing
    alias vSpacing getVSpacing
  end
  class FX_Popup
    alias frameStyle= setFrameStyle
    alias frameStyle getFrameStyle
    alias borderWidth getBorderWidth
    alias hiliteColor= setHiliteColor
    alias hiliteColor getHiliteColor
    alias shadowColor= setShadowColor
    alias shadowColor getShadowColor
    alias borderColor= setBorderColor
    alias borderColor getBorderColor
    alias baseColor= setBaseColor
    alias baseColor getBaseColor
    alias grabOwner getGrabOwner
    alias orientation getOrientation
    alias orientation= setOrientation
    alias shrinkWrap getShrinkWrap
    alias shrinkWrap= setShrinkWrap
  end
  class FX_PrintDialog
    alias printer= setPrinter
    alias printer getPrinter
  end
  class FX_ProgressBar
    alias progress= setProgress
    alias progress getProgress
    alias total= setTotal
    alias total getTotal
    alias barSize= setBarSize
    alias barSize getBarSize
    alias barBGColor= setBarBGColor
    alias barBGColor getBarBGColor
    alias barColor= setBarColor
    alias barColor getBarColor
    alias textColor= setTextColor
    alias textColor getTextColor
    alias textAltColor= setTextAltColor
    alias textAltColor getTextAltColor
    alias font= setFont
    alias font getFont
    alias barStyle= setBarStyle
    alias barStyle getBarStyle
  end
  class FX_ProgressDialog
    alias message= setMessage
    alias message getMessage
    alias progress= setProgress
    alias progress getProgress
    alias total= setTotal
    alias total getTotal
    alias cancelled? isCancelled
  end
  class FX_RadioButton
    alias check= setCheck
    alias check getCheck
    alias radioButtonStyle= setRadioButtonStyle
    alias radioButtonStyle getRadioButtonStyle
    alias radioColor getRadioColor
    alias radioColor= setRadioColor
  end
  class FXRange
    alias empty? empty
    alias contains? contains
  end
  class FX_RecentFiles
    alias maxFiles= setMaxFiles
    alias maxFiles getMaxFiles
    alias groupName= setGroupName
    alias groupName getGroupName
    alias target= setTarget
    alias target getTarget
    alias selector= setSelector
    alias selector getSelector
  end
  class FXRegistry
    alias appKey getAppKey
    alias vendorKey getVendorKey
    alias asciiMode= setAsciiMode
    alias asciiMode getAsciiMode
  end
  class FX_ReplaceDialog
    alias searchText= setSearchText
    alias searchText getSearchText
    alias replaceText= setReplaceText
    alias replaceText getReplaceText
    alias searchMode= setSearchMode
    alias searchMode getSearchMode
  end
  class FX_ScrollArea
    alias viewportWidth         getViewportWidth
    alias viewportHeight        getViewportHeight
    alias contentWidth          getContentWidth
    alias contentHeight         getContentHeight
    alias scrollStyle=          setScrollStyle
    alias scrollStyle           getScrollStyle
    alias horizontalScrollable? isHorizontalScrollable
    alias verticalScrollable?   isVerticalScrollable
    alias xPosition             getXPosition
    alias yPosition             getYPosition
  end
  class FX_Scrollbar
    alias range= setRange
    alias range getRange
    alias page= setPage
    alias page getPage
    alias line= setLine
    alias line getLine
    alias position= setPosition
    alias position getPosition
    alias hiliteColor= setHiliteColor
    alias hiliteColor getHiliteColor
    alias shadowColor= setShadowColor
    alias shadowColor getShadowColor
    alias borderColor getBorderColor
    alias borderColor= setBorderColor
    alias scrollbarStyle getScrollbarStyle
    alias scrollbarStyle= setScrollbarStyle
  end
  class FX_SearchDialog
    alias searchText= setSearchText
    alias searchText getSearchText
    alias searchMode= setSearchMode
    alias searchMode getSearchMode
  end
  class FXSettings
    alias modified= setModified
    alias modified? isModified
  end
  class FX_ShutterItem
    alias button getButton
    alias content getContent
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
  end
  class FX_Shutter
    alias current= setCurrent
    alias current getCurrent
  end
  class FX_Slider
    alias value= setValue
    alias value getValue
    alias sliderStyle getSliderStyle
    alias sliderStyle= setSliderStyle
    alias headSize getHeadSize
    alias headSize= setHeadSize
    alias slotSize getSlotSize
    alias slotSize= setSlotSize
    alias increment getIncrement
    alias increment= setIncrement
    alias tickDelta getTickDelta
    alias tickDelta= setTickDelta
    alias slotColor= setSlotColor
    alias slotColor getSlotColor
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
  end
  class FX_Spinner
    alias cyclic? isCyclic
    alias cyclic= setCyclic
    alias textVisible? isTextVisible
    alias textVisible= setTextVisible
    alias value= setValue
    alias value getValue
    alias font= setFont
    alias font getFont
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
    alias spinnerStyle= setSpinnerStyle
    alias spinnerStyle getSpinnerStyle
    alias editable= setEditable
    alias editable? isEditable
  end
  class FX_Splitter
    alias splitterStyle= setSplitterStyle
    alias splitterStyle getSplitterStyle
    alias barSize= setBarSize
    alias barSize getBarSize
  end
  class FX_Statusbar
    alias cornerStyle= setCornerStyle
    alias cornerStyle getCornerStyle
    alias statusline getStatusline
    alias dragCorner getDragCorner
  end
  class FX_Statusline
    alias text= setText
    alias text getText
    alias to_s getText
    alias normalText= setNormalText
    alias normalText getNormalText
    alias font= setFont
    alias font getFont
    alias textColor getTextColor
    alias textColor= setTextColor
    alias textHighlightColor getTextHighlightColor
    alias textHighlightColor= setTextHighlightColor
  end
  class FXStream
    alias swapBytes= setSwapBytes
    alias swapBytes getSwapBytes
  end
  class FX_Switcher
    alias current= setCurrent
    alias current getCurrent
    alias switcherStyle= setSwitcherStyle
    alias switcherStyle getSwitcherStyle
  end
  class FX_TabItem
    alias tabOrientation getTabOrientation
    alias tabOrientation= setTabOrientation
  end
  class FX_TabBar
    alias current= setCurrent
    alias current getCurrent
    alias tabStyle getTabStyle
    alias tabStyle= setTabStyle
  end
  class FX_TableItem
    alias text= setText
    alias text getText
    alias to_s getText
    alias icon= setIcon
    alias icon getIcon
    alias data= setData
    alias data getData
    alias selected= setSelected
    alias selected? isSelected
    alias enabled= setEnabled
    alias enabled? isEnabled
    alias draggable= setDraggable
    alias draggable? isDraggable
    alias justify= setJustify
    alias justify getJustify
    alias iconPosition= setIconPosition
    alias iconPosition getIconPosition
    alias borders= setBorders
    alias borders getBorders
    alias stipple= setStipple
    alias stipple getStipple
    alias button= setButton
    alias button? isButton
    alias pressed= setPressed
    alias pressed? isPressed
    alias iconOwned= setIconOwned
    alias iconOwned? isIconOwned
  end
  class FX_Table
    alias visibleRows= setVisibleRows
    alias visibleRows getVisibleRows
    alias visibleCols= setVisibleCols
    alias visibleCols getVisibleCols
    alias numRows getNumRows
    alias numCols getNumCols
    alias marginTop= setMarginTop
    alias marginTop getMarginTop
    alias marginBottom= setMarginBottom
    alias marginBottom getMarginBottom
    alias marginLeft= setMarginLeft
    alias marginLeft getMarginLeft
    alias marginRight= setMarginRight
    alias marginRight getMarginRight
    alias tableStyle getTableStyle
    alias tableStyle= setTableStyle
    alias leadingRows= setLeadingRows
    alias leadingRows getLeadingRows
    alias leadingCols= setLeadingCols
    alias leadingCols getLeadingCols
    alias trailingRows= setTrailingRows
    alias trailingRows getTrailingRows
    alias trailingCols= setTrailingCols
    alias trailingCols getTrailingCols
    alias defColumnWidth= setDefColumnWidth
    alias defColumnWidth getDefColumnWidth
    alias defRowHeight= setDefRowHeight
    alias defRowHeight getDefRowHeight
    alias currentRow getCurrentRow
    alias currentColumn getCurrentColumn
    alias anchorRow getAnchorRow
    alias anchorColumn getAnchorColumn
    alias font= setFont
    alias font getFont
    alias textColor= setTextColor
    alias textColor getTextColor
    alias baseColor= setBaseColor
    alias baseColor getBaseColor
    alias hiliteColor= setHiliteColor
    alias hiliteColor getHiliteColor
    alias shadowColor= setShadowColor
    alias shadowColor getShadowColor
    alias borderColor= setBorderColor
    alias borderColor getBorderColor
    alias selBackColor= setSelBackColor
    alias selBackColor getSelBackColor
    alias selTextColor= setSelTextColor
    alias selTextColor getSelTextColor
    alias gridColor= setGridColor
    alias gridColor getGridColor
    alias stippleColor= setStippleColor
    alias stippleColor getStippleColor
    alias cellBorderColor= setCellBorderColor
    alias cellBorderColor getCellBorderColor
    alias cellBorderWidth= setCellBorderWidth
    alias cellBorderWidth getCellBorderWidth
    alias helpText= setHelpText
    alias helpText getHelpText
  end
  class FX_Text
    alias marginTop= setMarginTop
    alias marginTop getMarginTop
    alias marginBottom= setMarginBottom
    alias marginBottom getMarginBottom
    alias marginLeft= setMarginLeft
    alias marginLeft getMarginLeft
    alias marginRight= setMarginRight
    alias marginRight getMarginRight
    alias wrapColumns getWrapColumns
    alias wrapColumns= setWrapColumns
    alias tabColumns getTabColumns
    alias tabColumns= setTabColumns
    alias barColumns getBarColumns
    alias barColumns= setBarColumns
    alias modified? isModified
    alias modified= setModified
    alias editable? isEditable
    alias editable= setEditable
    alias styled= setStyled
    alias styled? isStyled
    alias delimiters= setDelimiters
    alias delimiters getDelimiters
    alias font= setFont
    alias font getFont
    alias textColor= setTextColor
    alias textColor getTextColor
    alias selBackColor= setSelBackColor
    alias selBackColor getSelBackColor
    alias selTextColor= setSelTextColor
    alias selTextColor getSelTextColor
    alias hiliteTextColor= setHiliteTextColor
    alias hiliteTextColor getHiliteTextColor
    alias hiliteBackColor= setHiliteBackColor
    alias hiliteBackColor getHiliteBackColor
    alias activeBackColor= setActiveBackColor
    alias activeBackColor getActiveBackColor
    alias cursorColor= setCursorColor
    alias cursorColor getCursorColor
    alias numberColor= setNumberColor
    alias numberColor getNumberColor
    alias barColor= setBarColor
    alias barColor getBarColor
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
    alias text= setText
    alias text getText
    alias to_s getText
    alias length getLength
    alias topLine= setTopLine
    alias topLine getTopLine
    alias bottomLine= setBottomLine
    alias bottomLine getBottomLine
    alias centerLine= setCenterLine
    alias anchorPos= setAnchorPos
    alias anchorPos getAnchorPos
    alias cursorPos= setCursorPos
    alias cursorRow= setCursorRow
    alias cursorRow getCursorRow
    alias cursorCol= setCursorCol
    alias cursorCol getCursorCol
    alias cursorPos getCursorPos
    alias selStartPos getSelStartPos
    alias selEndPos getSelEndPos
    alias textStyle= setTextStyle
    alias textStyle getTextStyle
    alias visRows= setVisRows
    alias visRows getVisRows
    alias visCols= setVisCols
    alias visCols getVisCols
    alias hiliteMatchTime= setHiliteMatchTime
    alias hiliteMatchTime getHiliteMatchTime
    alias hiliteStyles= setHiliteStyles
    alias hiliteStyles getHiliteStyles
  end
  class FX_TextField
    alias editable? isEditable
    alias editable= setEditable
    alias cursorPos= setCursorPos
    alias cursorPos getCursorPos
    alias anchorPos= setAnchorPos
    alias anchorPos getAnchorPos
    alias text= setText
    alias text getText
    alias to_s getText
    alias font= setFont
    alias font getFont
    alias textColor= setTextColor
    alias textColor getTextColor
    alias selBackColor= setSelBackColor
    alias selBackColor getSelBackColor
    alias selTextColor= setSelTextColor
    alias selTextColor getSelTextColor
    alias numColumns= setNumColumns
    alias numColumns getNumColumns
    alias justify= setJustify
    alias justify getJustify
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
    alias textStyle= setTextStyle
    alias textStyle getTextStyle
  end
  class FX_TIFIcon
    alias codec= setCodec
    alias codec getCodec
  end
  class FX_TIFImage
    alias codec= setCodec
    alias codec getCodec
  end
  class FX_ToggleButton
    alias altText= setAltText
    alias altText getAltText
    alias altIcon= setAltIcon
    alias altIcon getAltIcon
    alias state= setState
    alias state getState
    alias altHelpText= setAltHelpText
    alias altHelpText getAltHelpText
    alias altTipText= setAltTipText
    alias altTipText getAltTipText
    alias toggleStyle= setToggleStyle
    alias toggleStyle getToggleStyle
  end
  class FX_Toolbar
    alias dryDock getDryDock
    alias wetDock getWetDock
    alias docked? isDocked
    alias dockingSide= setDockingSide
    alias dockingSide getDockingSide
  end
  class FX_ToolbarGrip
    alias doubleBar= setDoubleBar
    alias doubleBar getDoubleBar
    alias hiliteColor= setHiliteColor
    alias hiliteColor getHiliteColor
    alias shadowColor= setShadowColor
    alias shadowColor getShadowColor
    alias activeColor= setActiveColor
    alias activeColor getActiveColor
  end
  class FX_ToolbarShell
    alias frameStyle= setFrameStyle
    alias frameStyle getFrameStyle
    alias borderWidth getBorderWidth
    alias hiliteColor= setHiliteColor
    alias hiliteColor getHiliteColor
    alias shadowColor= setShadowColor
    alias shadowColor getShadowColor
    alias borderColor= setBorderColor
    alias borderColor getBorderColor
    alias baseColor= setBaseColor
    alias baseColor getBaseColor
  end
  class FX_ToolbarTab
    alias collapsed? isCollapsed
    alias tabStyle= setTabStyle
    alias tabStyle getTabStyle
    alias activeColor getActiveColor
    alias activeColor= setActiveColor
  end
  class FX_Tooltip
    alias text= setText
    alias text getText
    alias to_s getText
    alias font= setFont
    alias font getFont
    alias textColor getTextColor
    alias textColor= setTextColor
  end
  class FX_TopWindow
    alias iconified? isIconified
    alias title= setTitle
    alias title getTitle
    alias padTop= setPadTop
    alias padTop getPadTop
    alias padBottom= setPadBottom
    alias padBottom getPadBottom
    alias padLeft= setPadLeft
    alias hSpacing getHSpacing
    alias vSpacing getVSpacing
    alias hSpacing= setHSpacing
    alias vSpacing= setVSpacing
    alias packingHints= setPackingHints
    alias packingHints getPackingHints
    alias decorations= setDecorations
    alias decorations getDecorations
    alias icon getIcon
    alias icon= setIcon
    alias miniIcon getMiniIcon
    alias miniIcon= setMiniIcon
  end
  class FX_TreeItem
    alias parent getParent
    alias next getNext
    alias prev getPrev
    alias first getFirst
    alias last getLast
    alias below getBelow
    alias above getAbove
    alias numChildren getNumChildren
    alias text= setText
    alias text getText
    alias to_s getText
    alias openIcon= setOpenIcon
    alias openIcon getOpenIcon
    alias closedIcon= setClosedIcon
    alias closedIcon getClosedIcon
    alias data= setData
    alias data getData
    alias selected= setSelected
    alias selected? isSelected
    alias opened= setOpened
    alias opened? isOpened
    alias expanded= setExpanded
    alias expanded? isExpanded
    alias enabled= setEnabled
    alias enabled? isEnabled
    alias draggable= setDraggable
    alias draggable? isDraggable
    alias iconOwned= setIconOwned
    alias iconOwned isIconOwned
  end
  class FX_TreeList
    alias numItems getNumItems
    alias numVisible getNumVisible
    alias numVisible= setNumVisible
    alias firstItem getFirstItem
    alias lastItem getLastItem
    alias currentItem= setCurrentItem
    alias currentItem getCurrentItem
    alias anchorItem= setAnchorItem
    alias anchorItem getAnchorItem
    alias cursorItem getCursorItem
    alias font= setFont
    alias font getFont
    alias indent= setIndent
    alias indent getIndent
    alias textColor getTextColor
    alias textColor= setTextColor
    alias selBackColor getSelBackColor
    alias selBackColor= setSelBackColor
    alias selTextColor getSelTextColor
    alias selTextColor= setSelTextColor
    alias lineColor getLineColor
    alias lineColor= setLineColor
    alias listStyle getListStyle
    alias listStyle= setListStyle
    alias helpText= setHelpText
    alias helpText getHelpText
  end
  class FX_TreeListBox
    alias numItems getNumItems
    alias numVisible getNumVisible
    alias numVisible= setNumVisible
    alias firstItem getFirstItem
    alias lastItem getLastItem
    alias currentItem= setCurrentItem
    alias currentItem getCurrentItem
    alias paneShown? isPaneShown
    alias font= setFont
    alias font getFont
    alias listStyle getListStyle
    alias listStyle= setListStyle
    alias helpText= setHelpText
    alias helpText getHelpText
    alias tipText= setTipText
    alias tipText getTipText
  end
  class FX_Visual
    alias flags getFlags
    alias depth getDepth
    alias numColors getNumColors
    alias numRed getNumRed
    alias numGreen getNumGreen
    alias numBlue getNumBlue
    alias maxColors= setMaxColors
    alias maxColors getMaxColors
  end
  class FX_Window
    alias parent getParent
    alias owner getOwner
    alias shell getShell
    alias root getRoot
    alias next getNext
    alias prev getPrev
    alias first getFirst
    alias last getLast
    alias focus getFocus
    alias key= setKey
    alias key getKey
    alias target= setTarget
    alias target getTarget
    alias selector= setSelector
    alias message= setSelector
    alias selector getSelector
    alias message getSelector
    alias x getX
    alias y getY
    alias defaultWidth getDefaultWidth
    alias defaultHeight getDefaultHeight
    alias x= setX
    alias y= setY
    alias width= setWidth
    alias height= setHeight
    alias layoutHints= setLayoutHints
    alias layoutHints getLayoutHints
    alias accelTable getAccelTable
    alias accelTable= setAccelTable
    alias defaultCursor= setDefaultCursor
    alias defaultCursor getDefaultCursor
    alias dragCursor= setDragCursor
    alias dragCursor getDragCursor
    alias enabled? isEnabled
    alias active? isActive
    alias composite? isComposite
    alias dropEnabled? isDropEnabled
    alias dragging? isDragging
    alias dropTarget? isDropTarget
    alias backColor= setBackColor
    alias backColor getBackColor
    alias children getChildren
  end
end
